/*
 * Fabric3
 * Copyright  2008 Metaform Systems Limited
 *
 * This proprietary software may be used only connection with the Fabric3 license
 * (the License), a copy of which is included in the software or may be
 * obtained at: http://www.metaformsystems.com/licenses/license.html.

 * Software distributed under the License is distributed on an as is basis,
 * without warranties or conditions of any kind.  See the License for the
 * specific language governing permissions and limitations of use of the software.
 * This software is distributed in conjunction with other software licensed under
 * different terms.  See the separate licenses for those programs included in the
 * distribution for the permitted and restricted uses of such software.
 *
 */
package org.fabric3.pojo.injection;

import org.osoa.sca.Conversation;

import org.fabric3.spi.invocation.WorkContextTunnel;
import org.fabric3.spi.ObjectFactory;
import org.fabric3.spi.invocation.WorkContext;
import org.fabric3.spi.invocation.CallFrame;

public class ConversationIDObjectFactory implements ObjectFactory<String> {

    public ConversationIDObjectFactory() {
    }

    public String getInstance() {
        WorkContext workContext = WorkContextTunnel.getThreadWorkContext();
        CallFrame frame = workContext.peekCallFrame();
        Conversation conversation = frame.getConversation();
        if (conversation == null) {
            return null;
        }
        Object id = conversation.getConversationID();
        return String.valueOf(id);
    }
}
